package asd.td8;

import asd.graphe.*;

/**
 * EXERCICE 2 - TD 8
 * Une classe pour dterminer les composantes connexes d'un graphe non
 * orient.
 */
public class CC {

    private GrapheNonOriente G;

    /**
     * Construit un objet CC pour dterminer les composantes connexes
     * du graphe G.
     */
    public CC(GrapheNonOriente G) {
	this.G  = G;
    }

    /**
     * Retourne un tableau cc tel que cc[u] = k si et seulement si le
     * sommet u est dans la composante connexe numro k, pour tout u
     * dans [0..G.ordre-1].
     * Complexit : O(S + A) o S est l'ordre du graphe et A le nombre
     * d'artes.
     */
    public int[] cc() { // parcourir
        int[] cc = new int[G.ordre()]; // cc[u] = le numro de composante
                                       // connexe de u
        int ncc = 1;                   // le numro de la composante courante
        for ( int i = 0; i < G.ordre(); i++ ) {
            cc[i] = 0; // cc[u] == 0 <==> u n'a pas t visit
        }

	for ( int i = 0; i < G.ordre(); i++ ) {
	    if ( cc[i] == 0 ) {
		visiter(i,cc,ncc++);
	    }
	}
        return cc;
    }

    /**
     * Visite le sous-graphe de sommet i en profondeur et positionne cc[u]
     * pour tous u sommet de ce sous-graphe (i inclus)  ncc.
     * Prcondition : cc[i] = 0
     * Complexit : O(Ai) o Ai est le nombre d'artes accessibles depuis i.
     */
    private void visiter(int i, int[] cc, int ncc) {
        cc[i] = ncc;
	Adjacents adj = G.adjacents(i);
	
	while ( adj.nonVide() ) {
	    int s = adj.suivant();
	    if ( cc[s] == 0 ) {
		visiter(s,cc,ncc);
	    }
	}
    }
}
