package asd.td8;

import asd.graphe.Adjacents;
import asd.graphe.GrapheOriente;

/**
 * EXERCICE 3 - TD 8
 * Une classe pour tester si un graphe orient est acyclique.
 */
public class CycleOriente {

    private GrapheOriente G;
    private int[] c;              // la couleur des sommets

    private static int blanc = 0; // c[u] == blanc si u n'a pas t visit
    private static int gris  = 1; // c[u] == gris si u est en cours de visite
    private static int noir  = 2; // c[u] == noir si on a tout explor depuis u

    /**
     * Construit un objet CycleNOriente pour tester si le graphe G
     * est acyclique.
     */
    public CycleOriente(GrapheOriente G) {
        this.G = G;
        this.c = new int[G.ordre()];
    }

    /**
     * Teste si le graphe est acyclique.
     */
    public boolean acyclique() {
        for ( int i = 0; i < G.ordre(); i++ )
            c[i] = blanc; // aucun sommet n'a t visit
        for ( int i = 0; i < G.ordre(); i++ )
            if ( c[i] == blanc )
                if ( ! acyclique(i) )
                    return false;
        return true;
    }

    /**
     * Visite le sous-graphe de sommet i en profondeur et recherche un cycle.
     * Prcondition : i est blanc
     * Postrelation : i est noir et tous les descendants de i sont noirs
     * Complexit : O(Ai) o Ai est le nombre d'arcs accessibles depuis i.
     */
    private boolean acyclique(int i) {
        c[i] = gris;
        Adjacents adj = G.adjacents(i);

        while ( adj.nonVide() ) {
            int s = adj.suivant();
            if ( c[s] == blanc ) {
                if ( ! acyclique(s) )
                    return false;
            }
            else
                if ( c[s] == gris )
                    return false;
        }
        c[i] = noir;
        return true;
    }
}
