package asd.td8;

import asd.graphe.Adjacents;
import asd.graphe.GrapheNonOriente;
import asd.base.FileStatique;

/**
 * EXERCICE 10 - TD 8
 * Une classe pour le calcul du diamtre d'un arbre.
 */
public class Diametre {

    private GrapheNonOriente G; // le graphe

    private int[] D;  // D[i] = la distance min de s  i o s est la racine
    private int[] p;  // p[v] = u <==> u est le pre de v

    public Diametre(GrapheNonOriente G) {
	this.G = G;
	this.D = new int[G.ordre()];
	this.p = new int[G.ordre()];
    }

    public int calculer() {
        return D[parcourir(parcourir(0))];
    }

    /*
     * Parcours le graphe G en largeur  partir du sommet s (la racine) et
     * retourne un sommet i tel que D[i] (la distance minimale en nombre
     * d'artes pour aller de s  i) soit maximum.
     * Complexit : O(S + A) o S et A sont respectivement le nombre de
     * sommets et d'artes de G.
     */
    private int parcourir(int s) {
	for( int i = 0; i < G.ordre(); i++ ){
		D[i] = -1;
		p[i] = -1;
	}

	FileStatique f = new FileStatique(G.ordre());
	D[s] = 0;

	ajouter(s,f);
        int max = 0;
        int i   = s;

	while ( nonVide(f) ) {

	    int u = enlever(f);  

	    Adjacents adj = G.adjacents(u);

	    while ( adj.nonVide() ) {
		int v = adj.suivant();
		if ( p[v] != u ) {

		    D[v] = D[u] + 1; 
		    p[v] = u;       
		    
                    if ( D[v] > max ) {
                        max = D[v];
                        i   = v;
                    }
		    ajouter(v,f);
		}
	    }
	}
        return i;
    }

    // pour se simplifier la vie

    private boolean nonVide(FileStatique f) {
        return ! f.vide();
    }

    private void ajouter(int i, FileStatique f) {
        f.ajouter(new Integer(i));
    }

    private int enlever(FileStatique f) {
        int i = ((Integer) f.suivant()).intValue();
        f.retirer();
        return i;
    }
}
